#include <stdio.h>
#include <stdlib.h>
#include "tree.h"

int CONSISTENT_ORDER = 0;

static tree_node *make_tree(int depth) {
  tree_node *tn;
  static tree_node *prev = NULL;

  tn = malloc(sizeof(tree_node));
  tn->value = depth;
  if (depth > 0) {
    if (CONSISTENT_ORDER) {
      tn->left = make_tree(depth - 1);
      tn->right = make_tree(depth - 1);
    } else {
      if (depth & 0x1) {
        tn->left = make_tree(depth - 1);
        tn->right = make_tree(depth - 1);
      } else {
        tn->right = make_tree(depth - 1);
        tn->left = make_tree(depth - 1);
      }
    }
  } else {
    tn->left = NULL;
    tn->right = NULL;
  }

  /* For list_sum: */
  tn->next = NULL;
  if (prev)
    prev->next = tn;
  prev = tn;

  return tn;
}

#define BM_TREE_DEPTH 23
#define BM_ITERS      10

int main() {
  tree_node *tn;
  int i;
  long sum = 0;
  if(CONSISTENT_ORDER)
    {
      printf("%s", "consistent_set is set!\n");
    }

  tn = make_tree(BM_TREE_DEPTH);

  for (i = 0; i < BM_ITERS; i++) {
    /* Pick one of the sum functions: */
    sum += tree_sum(tn);
  }

  printf("%ld\n", sum);

  return 0;
}
